/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the ReportConfigurationData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ReportConfigurationData{}

// ReportConfigurationData struct for ReportConfigurationData
type ReportConfigurationData struct {
	Template string `json:"template"`
	Frequency *string `json:"frequency,omitempty"`
	DateRange *string `json:"date_range,omitempty"`
	DateRangeFrom *time.Time `json:"date_range_from,omitempty"`
	DateRangeTo *time.Time `json:"date_range_to,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Filters map[string]interface{} `json:"filters,omitempty"`
	Grouping []ReportGroupBy `json:"grouping,omitempty"`
	Invisible []ReportGroupBy `json:"invisible,omitempty"`
	Sort []ReportConfigurationDataSortInner `json:"sort,omitempty"`
	// Data for templates other than interactions
	CustomData map[string]interface{} `json:"custom_data,omitempty"`
}

// NewReportConfigurationData instantiates a new ReportConfigurationData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportConfigurationData(template string) *ReportConfigurationData {
	this := ReportConfigurationData{}
	this.Template = template
	return &this
}

// NewReportConfigurationDataWithDefaults instantiates a new ReportConfigurationData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportConfigurationDataWithDefaults() *ReportConfigurationData {
	this := ReportConfigurationData{}
	return &this
}

// GetTemplate returns the Template field value
func (o *ReportConfigurationData) GetTemplate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Template
}

// GetTemplateOk returns a tuple with the Template field value
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetTemplateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Template, true
}

// SetTemplate sets field value
func (o *ReportConfigurationData) SetTemplate(v string) {
	o.Template = v
}

// GetFrequency returns the Frequency field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetFrequency() string {
	if o == nil || IsNil(o.Frequency) {
		var ret string
		return ret
	}
	return *o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetFrequencyOk() (*string, bool) {
	if o == nil || IsNil(o.Frequency) {
		return nil, false
	}
	return o.Frequency, true
}

// HasFrequency returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasFrequency() bool {
	if o != nil && !IsNil(o.Frequency) {
		return true
	}

	return false
}

// SetFrequency gets a reference to the given string and assigns it to the Frequency field.
func (o *ReportConfigurationData) SetFrequency(v string) {
	o.Frequency = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *ReportConfigurationData) SetDateRange(v string) {
	o.DateRange = &v
}

// GetDateRangeFrom returns the DateRangeFrom field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetDateRangeFrom() time.Time {
	if o == nil || IsNil(o.DateRangeFrom) {
		var ret time.Time
		return ret
	}
	return *o.DateRangeFrom
}

// GetDateRangeFromOk returns a tuple with the DateRangeFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetDateRangeFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.DateRangeFrom) {
		return nil, false
	}
	return o.DateRangeFrom, true
}

// HasDateRangeFrom returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasDateRangeFrom() bool {
	if o != nil && !IsNil(o.DateRangeFrom) {
		return true
	}

	return false
}

// SetDateRangeFrom gets a reference to the given time.Time and assigns it to the DateRangeFrom field.
func (o *ReportConfigurationData) SetDateRangeFrom(v time.Time) {
	o.DateRangeFrom = &v
}

// GetDateRangeTo returns the DateRangeTo field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetDateRangeTo() time.Time {
	if o == nil || IsNil(o.DateRangeTo) {
		var ret time.Time
		return ret
	}
	return *o.DateRangeTo
}

// GetDateRangeToOk returns a tuple with the DateRangeTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetDateRangeToOk() (*time.Time, bool) {
	if o == nil || IsNil(o.DateRangeTo) {
		return nil, false
	}
	return o.DateRangeTo, true
}

// HasDateRangeTo returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasDateRangeTo() bool {
	if o != nil && !IsNil(o.DateRangeTo) {
		return true
	}

	return false
}

// SetDateRangeTo gets a reference to the given time.Time and assigns it to the DateRangeTo field.
func (o *ReportConfigurationData) SetDateRangeTo(v time.Time) {
	o.DateRangeTo = &v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *ReportConfigurationData) SetTags(v []string) {
	o.Tags = v
}

// GetFilters returns the Filters field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetFilters() map[string]interface{} {
	if o == nil || IsNil(o.Filters) {
		var ret map[string]interface{}
		return ret
	}
	return o.Filters
}

// GetFiltersOk returns a tuple with the Filters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetFiltersOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Filters) {
		return map[string]interface{}{}, false
	}
	return o.Filters, true
}

// HasFilters returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasFilters() bool {
	if o != nil && !IsNil(o.Filters) {
		return true
	}

	return false
}

// SetFilters gets a reference to the given map[string]interface{} and assigns it to the Filters field.
func (o *ReportConfigurationData) SetFilters(v map[string]interface{}) {
	o.Filters = v
}

// GetGrouping returns the Grouping field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetGrouping() []ReportGroupBy {
	if o == nil || IsNil(o.Grouping) {
		var ret []ReportGroupBy
		return ret
	}
	return o.Grouping
}

// GetGroupingOk returns a tuple with the Grouping field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetGroupingOk() ([]ReportGroupBy, bool) {
	if o == nil || IsNil(o.Grouping) {
		return nil, false
	}
	return o.Grouping, true
}

// HasGrouping returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasGrouping() bool {
	if o != nil && !IsNil(o.Grouping) {
		return true
	}

	return false
}

// SetGrouping gets a reference to the given []ReportGroupBy and assigns it to the Grouping field.
func (o *ReportConfigurationData) SetGrouping(v []ReportGroupBy) {
	o.Grouping = v
}

// GetInvisible returns the Invisible field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetInvisible() []ReportGroupBy {
	if o == nil || IsNil(o.Invisible) {
		var ret []ReportGroupBy
		return ret
	}
	return o.Invisible
}

// GetInvisibleOk returns a tuple with the Invisible field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetInvisibleOk() ([]ReportGroupBy, bool) {
	if o == nil || IsNil(o.Invisible) {
		return nil, false
	}
	return o.Invisible, true
}

// HasInvisible returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasInvisible() bool {
	if o != nil && !IsNil(o.Invisible) {
		return true
	}

	return false
}

// SetInvisible gets a reference to the given []ReportGroupBy and assigns it to the Invisible field.
func (o *ReportConfigurationData) SetInvisible(v []ReportGroupBy) {
	o.Invisible = v
}

// GetSort returns the Sort field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetSort() []ReportConfigurationDataSortInner {
	if o == nil || IsNil(o.Sort) {
		var ret []ReportConfigurationDataSortInner
		return ret
	}
	return o.Sort
}

// GetSortOk returns a tuple with the Sort field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetSortOk() ([]ReportConfigurationDataSortInner, bool) {
	if o == nil || IsNil(o.Sort) {
		return nil, false
	}
	return o.Sort, true
}

// HasSort returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasSort() bool {
	if o != nil && !IsNil(o.Sort) {
		return true
	}

	return false
}

// SetSort gets a reference to the given []ReportConfigurationDataSortInner and assigns it to the Sort field.
func (o *ReportConfigurationData) SetSort(v []ReportConfigurationDataSortInner) {
	o.Sort = v
}

// GetCustomData returns the CustomData field value if set, zero value otherwise.
func (o *ReportConfigurationData) GetCustomData() map[string]interface{} {
	if o == nil || IsNil(o.CustomData) {
		var ret map[string]interface{}
		return ret
	}
	return o.CustomData
}

// GetCustomDataOk returns a tuple with the CustomData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportConfigurationData) GetCustomDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.CustomData) {
		return map[string]interface{}{}, false
	}
	return o.CustomData, true
}

// HasCustomData returns a boolean if a field has been set.
func (o *ReportConfigurationData) HasCustomData() bool {
	if o != nil && !IsNil(o.CustomData) {
		return true
	}

	return false
}

// SetCustomData gets a reference to the given map[string]interface{} and assigns it to the CustomData field.
func (o *ReportConfigurationData) SetCustomData(v map[string]interface{}) {
	o.CustomData = v
}

func (o ReportConfigurationData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ReportConfigurationData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["template"] = o.Template
	if !IsNil(o.Frequency) {
		toSerialize["frequency"] = o.Frequency
	}
	if !IsNil(o.DateRange) {
		toSerialize["date_range"] = o.DateRange
	}
	if !IsNil(o.DateRangeFrom) {
		toSerialize["date_range_from"] = o.DateRangeFrom
	}
	if !IsNil(o.DateRangeTo) {
		toSerialize["date_range_to"] = o.DateRangeTo
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	if !IsNil(o.Filters) {
		toSerialize["filters"] = o.Filters
	}
	if !IsNil(o.Grouping) {
		toSerialize["grouping"] = o.Grouping
	}
	if !IsNil(o.Invisible) {
		toSerialize["invisible"] = o.Invisible
	}
	if !IsNil(o.Sort) {
		toSerialize["sort"] = o.Sort
	}
	if !IsNil(o.CustomData) {
		toSerialize["custom_data"] = o.CustomData
	}
	return toSerialize, nil
}

type NullableReportConfigurationData struct {
	value *ReportConfigurationData
	isSet bool
}

func (v NullableReportConfigurationData) Get() *ReportConfigurationData {
	return v.value
}

func (v *NullableReportConfigurationData) Set(val *ReportConfigurationData) {
	v.value = val
	v.isSet = true
}

func (v NullableReportConfigurationData) IsSet() bool {
	return v.isSet
}

func (v *NullableReportConfigurationData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportConfigurationData(val *ReportConfigurationData) *NullableReportConfigurationData {
	return &NullableReportConfigurationData{value: val, isSet: true}
}

func (v NullableReportConfigurationData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportConfigurationData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


